<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InterCompanyJournalEntryLineList StructType
 * @subpackage Structs
 */
class InterCompanyJournalEntryLineList extends AbstractStructBase
{
    /**
     * The line
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InterCompanyJournalEntryLine[]
     */
    public $line;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for InterCompanyJournalEntryLineList
     * @uses InterCompanyJournalEntryLineList::setLine()
     * @uses InterCompanyJournalEntryLineList::setReplaceAll()
     * @param \StructType\InterCompanyJournalEntryLine[] $line
     * @param bool $replaceAll
     */
    public function __construct(array $line = array(), $replaceAll = true)
    {
        $this
            ->setLine($line)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get line value
     * @return \StructType\InterCompanyJournalEntryLine[]|null
     */
    public function getLine()
    {
        return $this->line;
    }
    /**
     * This method is responsible for validating the values passed to the setLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLineForArrayConstraintsFromSetLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $interCompanyJournalEntryLineListLineItem) {
            // validation for constraint: itemType
            if (!$interCompanyJournalEntryLineListLineItem instanceof \StructType\InterCompanyJournalEntryLine) {
                $invalidValues[] = is_object($interCompanyJournalEntryLineListLineItem) ? get_class($interCompanyJournalEntryLineListLineItem) : sprintf('%s(%s)', gettype($interCompanyJournalEntryLineListLineItem), var_export($interCompanyJournalEntryLineListLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The line property can only contain items of type \StructType\InterCompanyJournalEntryLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set line value
     * @throws \InvalidArgumentException
     * @param \StructType\InterCompanyJournalEntryLine[] $line
     * @return \StructType\InterCompanyJournalEntryLineList
     */
    public function setLine(array $line = array())
    {
        // validation for constraint: array
        if ('' !== ($lineArrayErrorMessage = self::validateLineForArrayConstraintsFromSetLine($line))) {
            throw new \InvalidArgumentException($lineArrayErrorMessage, __LINE__);
        }
        $this->line = $line;
        return $this;
    }
    /**
     * Add item to line value
     * @throws \InvalidArgumentException
     * @param \StructType\InterCompanyJournalEntryLine $item
     * @return \StructType\InterCompanyJournalEntryLineList
     */
    public function addToLine(\StructType\InterCompanyJournalEntryLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterCompanyJournalEntryLine) {
            throw new \InvalidArgumentException(sprintf('The line property can only contain items of type \StructType\InterCompanyJournalEntryLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->line[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\InterCompanyJournalEntryLineList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
